function G_Map(opt_name) {
this.debugZone = "map";
this.name_ = opt_name ? opt_name : "noname";
this.membersArray_ = [];
this.membersMap_ = {};
this.size_ = 0;
}
G_Map.prototype.insert = function(key, value) {
if (key == null)
throw new Error("Can't use null as a key");
else if (typeof key == "object")
throw new Error("This class is not objectsafe; use ObjectSafeMap");
if (value === undefined)
throw new Error("Can't store undefined values in this map");
var oldIndexInArray = this.membersMap_[key];
if (typeof oldIndexInArray == "number")
this.membersArray_[oldIndexInArray] = undefined;
else
this.size_++;
var indexInArray = this.membersArray_.length;
this.membersArray_.push({ "key": key, "value": value});
this.membersMap_[key] = indexInArray;
}
G_Map.prototype.erase = function(key) {
var indexInArray = this.membersMap_[key];
if (indexInArray === undefined)
return false;
this.size_--;
delete this.membersMap_[key];
this.membersArray_[indexInArray] = undefined;
return true;
}
G_Map.prototype.find_ = function(key) {
var indexInArray = this.membersMap_[key];
return ((indexInArray === undefined) ?
undefined :
this.membersArray_[indexInArray].value);
}
G_Map.prototype.find = function(key) {
return this.find_(key);
}
G_Map.prototype.getList = function() {
return this.membersArray_;
}
G_Map.prototype.replace = function(other) {
this.membersMap_ = {};
this.membersArray_ = [];
var otherList = other.getList();
for (var i = 0; i < otherList.length; i++)
if (otherList[i]) {
var index = this.membersArray_.length;
this.membersArray_.push(otherList[i]);
this.membersMap_[otherList[i].key] = index;
}
this.size_ = other.size();
}
G_Map.prototype.forEach = function(func) {
if (typeof func != "function")
throw new Error("argument to forEach is not a function, it's a(n) " +
typeof func);
for (var i = 0; i < this.membersArray_.length; i++)
if (this.membersArray_[i])
func(this.membersArray_[i].key, this.membersArray_[i].value);
}
G_Map.prototype.size = function() {
return this.size_;
}
