function PROT_VersionParser(type, opt_major, opt_minor) {
this.debugZone = "versionparser";
this.type = type;
this.major = 0;
this.minor = 0;
this.update = false;
if (opt_major)
this.major = parseInt(opt_major);
if (opt_minor)
this.minor = parseInt(opt_minor);
}
PROT_VersionParser.prototype.toString = function() {
return "[" + this.type + " " + this.major + "." + this.minor + "]";
}
PROT_VersionParser.prototype.toUrl = function() {
return this.major + ":" + this.minor;
}
PROT_VersionParser.prototype.fromString = function(line) {
if (line[0] != '[' || line.slice(-1) != ']')
return false;
var description = line.slice(1, -1);
var tokens = description.split(" ");
this.type = tokens[0];
var majorminor = tokens[1].split(".");
this.major = parseInt(majorminor[0]);
this.minor = parseInt(majorminor[1]);
if (tokens.length >= 3) {
this.update = tokens[2] == "update";
}
return true;
}
function PROT_WireFormatWriter(threadQueue) {
this.threadQueue_ = threadQueue;
this.debugZone = "wireformatwriter";
}
PROT_WireFormatWriter.prototype.serialize = function(tableData,
vParser,
callback) {
if (this.callback_) {
G_Debug(this, "Serializer busy");
return false;
}
this.callback_ = callback;
this.current_ = 0;
this.serialized_ = vParser.toString() + "\n";
this.keyValList_ = tableData.getList();
this.threadQueue_.addWorker(BindToObject(this.doWorkUnit, this),
BindToObject(this.isComplete, this));
this.threadQueue_.run();
return true;
}
PROT_WireFormatWriter.prototype.doWorkUnit = function() {
for (var i = 0; i < 10 && this.current_ < this.keyValList_.length; i++) {
if (this.keyValList_[this.current_]) {
this.serialized_ += "+" +
this.keyValList_[this.current_].key + "\t" +
this.keyValList_[this.current_].value + "\n";
}
this.current_++;
}
if (this.isComplete())
this.onComplete();
}
PROT_WireFormatWriter.prototype.isComplete = function() {
return this.current_ >= this.keyValList_.length;
}
PROT_WireFormatWriter.prototype.onComplete = function() {
this.callback_(this.serialized_);
this.callback_ = null;
}
function PROT_WireFormatReader(threadQueue, opt_existingTablesData) {
this.debugZone = "wireformatreader";
this.existingTablesData_ = opt_existingTablesData;
this.threadQueue_ = threadQueue;
this.callback_ = null;
}
PROT_WireFormatReader.prototype.deserialize = function(tableUpdate, callback) {
this.tableUpdate_ = tableUpdate;
this.tablesKnown_ = {}
this.tablesData_ = {}
if (this.callback_ != null) {
G_Debug(this, "previous deserialize is still running");
return false;
}
this.callback_ = callback;
this.offset_ = 0;
this.resetTableState();
if (!this.tableUpdate_ || !this.tableUpdate_.length) {
G_Debug(this, "No data. Calling back.");
this.onComplete();
return true;
}
this.threadQueue_.addWorker(BindToObject(this.processLine, this),
BindToObject(this.isComplete, this));
this.threadQueue_.run();
return true;
}
PROT_WireFormatReader.prototype.resetTableState = function() {
this.vParser_ = null;
this.insert_ = 0;
this.remove_ = 0;
}
PROT_WireFormatReader.prototype.processNewTable = function(line) {
this.vParser_ = new PROT_VersionParser("something");
this.vParser_.fromString(line);
G_Debug(this, this.vParser_.type + ": " +
this.vParser_.major + ":" + this.vParser_.minor + " " +
this.vParser_.update);
this.tablesData_[this.vParser_.type] = new PROT_TRTable(this.vParser_.type);
if (this.vParser_.update && this.existingTablesData_ &&
this.existingTablesData_[this.vParser_.type]) {
this.tablesData_[this.vParser_.type].replace(
this.existingTablesData_[this.vParser_.type]);
}
}
PROT_WireFormatReader.prototype.processUpdateTable = function(line) {
var tokens = line.split("\t");
var operation = tokens[0][0];
var key = tokens[0].slice(1);
var value = tokens[1];
if (operation == "+") {
this.tablesData_[this.vParser_.type].insert(key, value);
this.insert_++;
} else {
this.tablesData_[this.vParser_.type].erase(key);
this.remove_++;
}
}
PROT_WireFormatReader.prototype.processLine = function() {
for (var count = 0;
count < 5 && this.offset_ < this.tableUpdate_.length; count++) {
var newOffset = this.tableUpdate_.indexOf("\n", this.offset_);
var line = "";
if (newOffset == -1) {
this.offset_ = this.tableUpdate_.length;
} else {
line = this.tableUpdate_.slice(this.offset_, newOffset);
this.offset_ = newOffset + 1;
}
if (!this.vParser_ && (!line || line[0] != '['))
continue;
if (!line) {
G_Debug(this,
"Finished: " + this.vParser_.type + " +" +
this.insert_ + " -" + this.remove_);
this.tablesKnown_[this.vParser_.type] = this.vParser_;
this.resetTableState();
} else if (line[0] == '[' && line.slice(-1) == ']') {
this.processNewTable(line);
} else {
if (!this.vParser_) {
G_Debug(this, "Ignoring: " + line);
continue;
}
this.processUpdateTable(line);
}
}
if (this.vParser_ && this.offset_ >= this.tableUpdate_.length) {
G_Debug(this,
"Finished (final table): " + this.vParser_.type + " +" +
this.insert_ + " -" + this.remove_);
this.tablesKnown_[this.vParser_.type] = this.vParser_;
this.resetTableState();
}
if (this.isComplete()) this.onComplete();
}
PROT_WireFormatReader.prototype.isComplete = function() {
return this.offset_ >= this.tableUpdate_.length;
}
PROT_WireFormatReader.prototype.onComplete = function() {
G_Debug(this, "Processing complete. Executing callback.");
this.callback_(this.tablesKnown_, this.tablesData_);
this.callback_ = null;
}
function TEST_PROT_WireFormat() {
if (G_GDEBUG) {
var z = "wireformat UNITTEST";
G_debugService.enableZone(z);
G_Debug(z, "Starting");
var testTablesData = {};
var tableName = "test-black-url";
var data1 = "[" + tableName + " 1.5]\n";
for (var i = 0; i < 100; i++)
data1 += "+http://exists" + i + "\t1\n";
data1 += "-http://exists50\t1\n";
data1 += "-http://exists666\t1\n";
function data1cb(tablesKnown, tablesData) {
G_Assert(z,
tablesData[tableName] != null,
"Didn't get our table back");
for (var i = 0; i < 100; i++)
if (i != 50)
G_Assert(z,
tablesData[tableName].find("http://exists" + i) == "1",
"Item addition broken");
G_Assert(z,
!tablesData[tableName].find("http://exists50"),
"Item removal broken");
G_Assert(z,
!tablesData[tableName].find("http://exists666"),
"Non-existent item");
G_Assert(z, tablesKnown[tableName].major == "1", "Major parsing broke");
G_Assert(z, tablesKnown[tableName].minor == "5", "Major parsing broke");
var data2 = "[" + tableName + " 1.7 update]\n";
for (var i = 0; i < 100; i++)
data2 += "-http://exists" + i + "\t1\n";
var wfr2 = new PROT_WireFormatReader(new TH_ThreadQueue(), tablesData);
wfr2.deserialize(data2, data2cb);
};
function data2cb(tablesKnown, tablesData) {
for (var i = 0; i < 100; i++)
G_Assert(z,
!tablesData[tableName].find("http://exists" + i),
"Tables merge broken");
G_Assert(z, tablesKnown[tableName].major == "1", "Major parsing broke");
G_Assert(z, tablesKnown[tableName].minor == "7", "Major parsing broke");
G_Debug(z, "PASSED");
};
var wfr = new PROT_WireFormatReader(new TH_ThreadQueue());
wfr.deserialize(data1, data1cb);
}
}
